
Redmine - Feature #4050

Ruby 1.9 support

2009-10-18 12:51 - Alexey Froloff

Status: Closed Start date: 2009-10-18

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Ruby support Estimated time: 0.00 hour

Target version: 1.4.0   

Resolution: Fixed   

Description

With attached patches redmine passes all tests with Rails 2.3.4 and Ruby 1.9.1.  I'm trying to package redmine for ALT Linux distro,

these patches are not distribution specific.

I have packaged and installed following modules (never tried to patch vendored versions):

ruby-coderay (http://svn.rubychan.de/coderay)

rails-plugin-engines (http://github.com/lazyatom/engines)

rails-plugin-rfpdf (http://github.com/edwinmoss/rfpdf)

Excerption from redmine spec just for reference:

rm -rf vendor/plugins/coderay*/

rm -rf vendor/plugins/engines/

rm -rf vendor/plugins/rfpdf/

# these locales fail test_load(DefaultDataTest)

rm -f config/locales/hu.yml

rm -f config/locales/zh.yml

rm -f config/locales/zh-TW.yml

cat <<EOF >config/database.yml

production:

  adapter: sqlite3

  database: db/production.db

development:

  adapter: sqlite3

  database: db/development.db

test:

  adapter: sqlite3

  database: db/test.db

EOF

rake --trace config/initializers/session_store.rb

rake --trace db:migrate

rake --trace test:scm:setup:create_dir

rake --trace test:scm:setup:filesystem

rake --trace test:scm:setup:git

rake --trace test:scm:setup:subversion

rake --trace test:units

rake --trace test:functionals

rake --trace test:integration

Related issues:

Related to Redmine - Defect #2664: Mercurial: Repository path encoding of non... Closed 2009-02-04

Related to Redmine - Defect #6853: Ruby 1.9: translation missing: en, field_l... Closed 2010-11-08

Related to Redmine - Feature #8209: I18n YAML files not parsable with psych y... Closed 2011-04-22

Related to Redmine - Defect #8847: I18n YAML files not parsable with psych ya... Closed 2011-07-19

Related to Redmine - Defect #9798: Release 1.3.0 does not detect rubytree und... Closed

Related to Redmine - Feature #10046: Update installation doc on release Closed
Related to Redmine - Defect #7096: CSV Issues Export + Ruby 1.9 + Thin + non-... Closed 2010-12-11

Related to Redmine - Defect #10575: Uploading of attachments which filename c... Closed

Related to Redmine - Defect #10593: Error: 'incompatible character encodings:... Closed

Has duplicate Redmine - Defect #8600: Encoding::CompatibilityError in Welcome... Closed 2011-06-14

Has duplicate Redmine - Defect #10051: Ruby 1.9.2 and mailer encoding Closed

Blocks Redmine - Defect #6725: Acronyms don't work for Russian language New 2010-10-22

Blocked by Redmine - Patch #4869: Redmine doesn't support ruby 1.9's radio bu... Closed 2010-02-18

Blocks Redmine - Defect #6551: Highlighting in search results is case sensiti... New 2010-10-01

Blocked by Redmine - Defect #4824: Unable to connect (can't convert Net::LDAP... Closed 2010-02-13 2010-02-17

Blocks Redmine - Defect #9730: Redmine leaks memory over 1G, YAML Closed

Blocks Redmine - Defect #10134: Case insensitive search is not working with p... Confirmed

Associated revisions

Revision 4359 - 2010-11-02 01:20 - Jean-Baptiste Barth

Use File#expand_path for require's in script/* for Ruby 1.9.2 compatibility. #4050

Since Ruby 1.9.2, LOAD_PATH does not include "." directory anymore, so

we should use absolute paths instead to ensure both 1.8.x and 1.9.x

compatibility. It has been included in railties 2.3.x branch since

july 2009, see http://github.com/rails/rails/commit/7a427a83ca4da92c70760007aaf313638a5d8374

Revision 4509 - 2010-12-13 00:24 - Jean-Baptiste Barth

Use absolute paths in test/**/* requires for Ruby 1.9.2 compatibility. #4050

Revision 4510 - 2010-12-13 00:24 - Jean-Baptiste Barth

Set encoding to utf-8 for ruby 1.9 compatibility. #4050

Revision 5000 - 2011-03-04 12:07 - Toshi MARUYAMA

scm: mercurial: add path encoding tests in functional test (#2664, #4050).

TODO: This test fails in Ruby 1.9 and Encoding.default_external is not UTF-8.

Revision 6461 - 2011-08-19 11:41 - Toshi MARUYAMA

Ruby 1.9: set Encoding.default_external = 'UTF-8' (#4050).

Without this setting, Redmine cannot boot on Japanese Windows

nor on non UTF-8 locale Linux (e.g. LANG=en_US.ISO-8859-1).

Revision 6462 - 2011-08-19 12:18 - Toshi MARUYAMA

Ruby 1.9: force use syck yaml library (#8847, #4050).

Revision 6647 - 2011-08-27 02:11 - Toshi MARUYAMA

Ruby 1.9: add rake task to check parsing yaml by psych library (#8847, #4050).

Original code is written by Etienne Massip.

Revision 6649 - 2011-08-27 02:18 - Toshi MARUYAMA

Ruby 1.9: fix typo of rake task name to check parsing yaml by psych library (#8847, #4050).

Revision 7927 - 2011-11-26 00:15 - Toshi MARUYAMA

Ruby 1.9: fix encoding error on wiki diffs (#4050)

WikiDiff#to_html returns a string with ASCII encoding if

the WikiJournal content has been Zlib compressed because

Zlib::Inflate.inflate returns strings with ASCII encoding.

Forcing the encoding to be UTF8 fixes this bug.

Contributed by Moritz Breit.

Revision 7928 - 2011-11-26 02:39 - Toshi MARUYAMA
Ruby 1.9: fix TabularFormBuilder to show "translation missing: en, field_lock_version" (#6853, #4050)

Contributed by Moritz Breit.

Revision 8713 - 2012-01-28 05:57 - Toshi MARUYAMA

Ruby1.9: set Encoding.default_external on only Rails2 (#4050, #4796)

Revision 8714 - 2012-01-28 05:58 - Toshi MARUYAMA

Ruby1.9: enforce UTF-8 encodings on the params hash on Rails2 (#4050, #4796)

Without this change, non ASCII subject issue cannot be created on Ruby 1.9.

Revision 8716 - 2012-01-28 11:26 - Toshi MARUYAMA

Ruby1.9: skip enforcing UTF-8 encodings on the params hash on Rails2 if it is frozen (#4050, #4796)

Tests on CI server fail.

http://www.redmine.org/builds/build_trunk-1.9.2-sqlite3_257.html

  1) Error:

test_index_with_short_filters(IssuesControllerTest):

RuntimeError: can't modify frozen string

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:58:in `force_

encoding'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:58:in `utf8ni

ze!'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:60:in `block 

in utf8nize!'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:60:in `each'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:60:in `utf8ni

ze!'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:52:in `params

_filter'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/activesupport-2.3.14/lib/active_support/callbacks.rb:17

8:in `evaluate_method'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/activesupport-2.3.14/lib/active_support/callbacks.rb:16

6:in `call'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:225:

in `call'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:629:

in `run_before_filters'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:615:

in `call_filters'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:610:

in `perform_action_with_filters'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/benchmarking.rb

:68:in `block in perform_action_with_benchmark'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/activesupport-2.3.14/lib/active_support/core_ext/benchm

ark.rb:17:in `block in ms'

Revision 8833 - 2012-02-10 14:08 - Toshi MARUYAMA

Ruby1.9: move setting Encoding.default_external after boot (#4050, #4796)

"ruby test/functional/repositories_git_controller_test.rb" fails

on Japanese Windows and Mingw Ruby 1.9.3p0

because "Rails" is not defined.

History

#1 - 2009-10-18 12:52 - Alexey Froloff

- File 0011-Process-fixtures-as-binary.patch added

#2 - 2009-10-18 12:53 - Alexey Froloff

Forgot to mention.  All patches made against yesterday's trunk.

#3 - 2010-07-19 22:37 - Holger Just

- Category set to Ruby support

#4 - 2010-08-25 14:33 - Etienne Massip
That would be great as ruby 1.9.2 is out now and is meant to be the first 1.9 release ready for production use.

This could improve greatly the speed and usability of Redmine.

#5 - 2010-08-25 14:41 - Alexey Froloff

$ git diff --stat tags/1.0.0..master -- app/ config/ lib/ test/ vendor/ | tail 1

60 files changed, 264 insertions(+), 220 deletions()

Works perfect with 1.9.1p376.  Since there's no reaction on my patches, I don't see any reason for me to submit anything again.

#6 - 2010-08-25 16:02 - Jean-Baptiste Barth

Alexey, please don't take it that way, be sure that such contributions are very appreciated.

There were no reaction to your patch for various reasons. Mainly because we are very few contributors around to review thousands of pending

issues. Plus, if I remember correctly, 1.9.1 has always been said to be not really ready for production (I remember articles about weird cases,

segfaults, etc.).

But now with 1.9.2 released, the situation is very different. I'd personnaly like 1.1 to be fully compatible with ruby 1.9, and maybe we'll begin to support

more recent rails versions.

I'll have a look at your patches and integrate them one by one as soon as I come back from my holidays in september. Thank you again.

#7 - 2010-08-25 16:43 - Alexey Froloff

This issue is already obsolete.  In http://git.altlinux.org/people/raorn/packages/?p=redmine.git I have  working redmine 1.0.0 (upstream sources were

imported with git-svn) with bunch of fixes related to 1.9.1 incompatibilities, encoding issues, rails 2.3.8 anti-XSS false-positive escapes as well as

several really nasty bugs.

I am packaging redmine for ALT Linux distro, we have ruby 1.9.1 as the only ruby version in repository.  I am doing this just for fun, although there are

several users who runs this version in their "production".

I can comment on any my commit, but submitting issues without any feedback in months don't worth the effort.  Nothing personal.

#8 - 2010-08-25 16:53 - Etienne Massip

This issue can't be obsolete, you just brought a considerable help to Redmine's development for which we, users, are very thankful.

BTW, it looks like someone else did the same to get early Rails 3 support (issue #4796) : http://github.com/jeremy/redmine

#9 - 2010-08-25 21:01 - Jean-Baptiste Barth

Alexey Froloff wrote:

This issue is already obsolete.  In http://git.altlinux.org/people/raorn/packages/?p=redmine.git I have  working redmine 1.0.0 (upstream sources

were imported with git-svn) with bunch of fixes related to 1.9.1 incompatibilities, encoding issues, rails 2.3.8 anti-XSS false-positive escapes as

well as several really nasty bugs.

 OK thanks, I mirrored this repo on my laptop so that I can hack a bit on it.

#10 - 2010-09-12 02:54 - David Morton

I'm very interested in this too, as I just spent a week or two getting an application ready for rails 3, and then I discovered that passenger needs to run

the same ruby version for all apps on the server - and so to run redmine on the testing server along with the application, I need both to run in 1.9.2. :(

Alexsey: you said 1.0.0, how is it tracking with 1.0.1 ?

#11 - 2011-03-04 06:24 - Toshi MARUYAMA

- File Ruby-1.9-Encoding.default_external.diff added

After Redmine updated Rails 2.3.11, I can't run on my Japanese Windows nor Linux Latin-1 locale on Ruby 1.9.

$ ruby --version

ruby 1.9.2p136 (2010-12-25 revision 30365) [x86_64-linux]

$ locale

LANG=en_US.ISO-8859-1

LC_CTYPE="en_US.ISO-8859-1" 

LC_NUMERIC="en_US.ISO-8859-1" 

LC_TIME="en_US.ISO-8859-1" 

LC_COLLATE="en_US.ISO-8859-1" 

LC_MONETARY="en_US.ISO-8859-1" 
LC_MESSAGES="en_US.ISO-8859-1" 

LC_PAPER="en_US.ISO-8859-1" 

LC_NAME="en_US.ISO-8859-1" 

LC_ADDRESS="en_US.ISO-8859-1" 

LC_TELEPHONE="en_US.ISO-8859-1" 

LC_MEASUREMENT="en_US.ISO-8859-1" 

LC_IDENTIFICATION="en_US.ISO-8859-1" 

LC_ALL=

 
ActionView::TemplateError (incompatible character encodings: UTF-8 and ISO-8859-1) on line #62 of app/views/la

youts/base.rhtml:

59:     

60:     <div id="content">

61:                 <%= render_flash_messages %>

62:         <%= yield %>

63:         <%= call_hook :view_layouts_base_content %>

64:                 <div style="clear:both;"></div>

65:     </div>

    app/views/layouts/base.rhtml:62:in `concat'

    app/views/layouts/base.rhtml:62:in `_run_rhtml_app47views47layouts47base46rhtml'

    <internal:prelude>:10:in `synchronize'

    /home/xxxxx/.rvm/rubies/ruby-1.9.2-p136/lib/ruby/1.9.1/webrick/httpserver.rb:111:in `service'

    /home/xxxxx/.rvm/rubies/ruby-1.9.2-p136/lib/ruby/1.9.1/webrick/httpserver.rb:70:in `run'

    /home/xxxxx/.rvm/rubies/ruby-1.9.2-p136/lib/ruby/1.9.1/webrick/server.rb:183:in `block in start_thread'

Rendered rescues/_trace (228.3ms)

Rendered rescues/_request_and_response (2.0ms)

Rendering rescues/layout (internal_server_error)

 I apply this patch, then I can run Redmine.

#12 - 2011-04-22 14:33 - Etienne Massip

- Target version set to Candidate for next major release

#13 - 2011-04-28 13:59 - Toshi MARUYAMA

- File application_controller.diff added

This is additional patch.

Without this patch, I can not input non ASCII characters.

#14 - 2011-06-14 04:41 - Toshi MARUYAMA

- Tracker changed from Patch to Feature

#15 - 2011-08-24 23:51 - Toshi MARUYAMA

FYI:

https://www.chiliproject.org/issues/591

#16 - 2011-10-30 12:46 - Toshi MARUYAMA

- File application_controller_chili_21a45b4e.diff added

This is an updating note-13 patch from https://www.chiliproject.org/issues/676

#17 - 2011-12-10 21:19 - Etienne Massip

- Target version changed from Candidate for next major release to 1.4.0

#18 - 2012-01-28 12:15 - Jean-Philippe Lang

r8714 breaks tests with ruby 1.9. I'd really like that this fix comes with a test so that we can safely remove it in the future.

#19 - 2012-02-01 16:22 - Toshi MARUYAMA

Japanese attachment filename is broken on Japanese Windows Ruby 1.9

https://www.chiliproject.org/issues/856

#20 - 2012-03-11 09:56 - Jean-Philippe Lang
- Status changed from New to Closed

- Resolution set to Fixed

I'm closing it as the test suite passes with both 1.9.2 and 1.9.3 (1.9.1 is not supported by Rails):

http://www.redmine.org/builds/index.html

Separate issues should be open if incompatibilities are found.

#21 - 2012-04-03 14:32 - Alexander Oryol

Please, add to related issue #10593

Files

0006-Fix-weird-characters.patch 1.32 KB 2009-10-18 Alexey Froloff

0007-Missing-users_groups-fixture.patch 1.13 KB 2009-10-18 Alexey Froloff

0008-Quotes-should-not-be-escaped.patch 1.21 KB 2009-10-18 Alexey Froloff

0009-Use-pt_BR-instead-of-buggy-zh_TW-locale.patch 2.04 KB 2009-10-18 Alexey Froloff

0001-New-CSV-API.patch 2.11 KB 2009-10-18 Alexey Froloff

0002-Round-up-Rational-value.patch 1.29 KB 2009-10-18 Alexey Froloff

0003-Object-methods-returns-Array-of-Symbols.patch 1.53 KB 2009-10-18 Alexey Froloff

0004-Fix-Regexp.patch 904 Bytes 2009-10-18 Alexey Froloff

0010-20000-days-is-less-than-55-years.patch 1.46 KB 2009-10-18 Alexey Froloff

0005-Do-not-require-non-existant-modules.patch 936 Bytes 2009-10-18 Alexey Froloff

0011-Process-fixtures-as-binary.patch 1.14 KB 2009-10-18 Alexey Froloff

Ruby-1.9-Encoding.default_external.diff 595 Bytes 2011-03-04 Toshi MARUYAMA

application_controller.diff 1.11 KB 2011-04-28 Toshi MARUYAMA

application_controller_chili_21a45b4e.diff 1.08 KB 2011-10-30 Toshi MARUYAMA
